#ifndef __GATEWAY_MESSAGE_H
#define __GATEWAY_MESSAGE_H
#include "gd32f30x.h"
#include "FreeRTOS.h"
#include "task.h"

// 洢modbusд
typedef struct _GATEWAY_WRITE_MODBUS_COMMAND
{
	uint16_t registerByteNum;
	uint8_t slaveAddress;
	uint8_t functionCode;
	uint8_t dataType;          //
	uint8_t keyword[20]; // дԵ
	uint8_t bigLittleFormat;
	uint16_t registerAddress;	// Ĵַ
	uint8_t write_command_flag; // Ƿɹдı־
	struct _GATEWAY_WRITE_MODBUS_COMMAND *nextParams;
} GATEWAY_WRITE_MODBUS_COMMAND;

// 洢modbus
typedef struct _GATEWAY_READ_MODBUS_COMMAND
{
	uint8_t slaveAddress;
	uint8_t functionCode;
	uint8_t keyword[20]; // Ե
	uint16_t registerAddress;  // Ĵַ
	uint8_t read_command_flag; // Ƿɹȡı־
	uint32_t value;          //ȡֵ
	uint16_t registerByteNum;
	uint8_t decimalPoint;
	struct _GATEWAY_READ_MODBUS_COMMAND *nextParams;
} GATEWAY_READ_MODBUS_COMMAND;


// ڵ洢DLT645ָ
typedef struct _GATEWAY_READ_DLT645_COMMAND
{
	uint8_t deviceID645[6];
	uint8_t keyword[20];   // Ե
	uint32_t Identification; // 645ݱʶ
	uint8_t data[9];	   // 
	uint8_t rxLen;		   // ӻӦֵĳ
	struct _GATEWAY_READ_DLT645_COMMAND *nextParams;
} GATEWAY_READ_DLT645_COMMAND;

typedef struct _PARAMS_PROTOCOL_COMMAND
{
	GATEWAY_READ_MODBUS_COMMAND   *gateway_read_modbus_command;
	GATEWAY_WRITE_MODBUS_COMMAND  *gateway_write_modbus_command;
	GATEWAY_READ_DLT645_COMMAND   *gateway_read_dlt645_command;
}PARAMS_PROTOCOL_COMMAND;


// ڵ豸Ϣ
typedef struct _DEVICE_PARAMS
{
	uint8_t aliveflag; // ֤(ѯб֤,ѯӦȷ·仯ʱϱ豸ѾȥѯӦӦֵʱȥϱѾ)
	uint8_t deviceID[20];
	uint8_t protocol;  // Э   1:modbus read 2:modbus write 3:dlt97  4:dlt07    һ豸ֻܴһЭ	
	uint8_t MDBbigLittleFormat;
	uint8_t MDBdataType;	
	PARAMS_PROTOCOL_COMMAND	*params;
	struct _DEVICE_PARAMS *nextDevice; // ָһ豸ַ
} DEVICE_PARAMS;


// ذ豸Ϣ
typedef struct _GATEWAY_PARAMS
{
	uint8_t data_valid_flag;  // Ч־  0xF1:Ч  :Ч
	uint8_t host[20];		  // MQTTַ
	uint16_t port;			  // MQTT˿ں
	uint8_t messageTopic[50]; // MQTTϢ
	uint8_t commandTopic[50]; // MQTTָ
	uint8_t username[20];			//MQTTû
	uint8_t passwd[20];				// MQTTû
	uint8_t deviceId[25];	  // 豸ID
	uint8_t dataSource;		  // Э                 0  1 ʾ645Э 2ʾmodbusЭ
	uint8_t dataType645;	  // 645Э          0  1 ʾ07汾  2ʾ97汾
	uint32_t pollTime;		  // ѯʱ
	uint32_t inboundTime;
	uint8_t state;			 // Ƿλùλù״̬λԺhttpȡӦ λֵΪ0xF1
	uint8_t gatewayId[10];	 // ̻Ϣ
	uint8_t gatewayMode[10]; // ģʽ汾ʹ
		uint8_t gateName[10];		// Ϣ

	// 豸ṹ
	uint8_t deviceCount;
	DEVICE_PARAMS *device_params;
		// ĴڹԽֻһ
	uint32_t baudrate;	 // 
	uint8_t dataBits;	 // λ
	uint8_t checkBit;	 // Уλ
	uint8_t stopBit;	 // ֹͣλ
	uint8_t flowControl; // 
	uint8_t parity;				//Уλ
	uint8_t bandwidth;	
} GATEWAY_PARAMS;

void addGatewayParams(char *gatewayString);
void addDevice(char *string);

int parseIntField(const char *data, const char *field);
void parseStringField(const char *data, const char *field, char *value);

GATEWAY_PARAMS *get_gateway_config_params(void);
int extract_substring(const char *input_string, const char *start_token, const char *end_token, char *result);


#endif
