#include "stdint.h"
#include "stdio.h"
#include "string.h"
#include "lwip/opt.h"
#include "lwip/arch.h"
#include "lwip/api.h"
#include "lwip/inet.h"
#include "lwip/sockets.h"
#include "lwip/dns.h"
#include "httpclient.h"

uint8_t httpSendBuffer[1024];
uint8_t httpRecvBuffer[512];



/**
  * @brief  socketжȡһhttp
	* @param  sock:    Ѿӵsock
	* @param  buf:     ݵbuffer
	* @param  size:    bufó
	* @retval ȡݵĳȣֽڵĻз
  */
int http_getLine(int sock, uint8_t *buf, int size)
{
	 int i = 0;
	 char c = '\0';
	 int n;
	
	 while((i < (size - 1)) && (c != '\n'))
	 {
			n = recv(sock, &c, 1, 0);
		  if(n <= 0) c = '\n';
			buf[i++] = c;
	 }
	 buf[i] = '\0';
 
	 return i;  //ضȡĵݳ
}

/**
  * @brief  httpӦ
	* @param  pbuf:  Ӧе
* @retval ֵ: http״̬   -1: ʧ
  */
int http_parseRequestLine(uint8_t *pbuf)
{
	int b, s, g;
	
	if((strncmp((char *)pbuf, "HTTP/1.1 ", strlen("HTTP/1.1 ")) == 0) || (strncmp((char *)pbuf, "http/1.1 ", strlen("http/1.1 ")) == 0))
	{
		pbuf += strlen("HTTP/1.1 ");
		b = pbuf[0] - '0';
		s = pbuf[1] - '0';
		g = pbuf[2] - '0';	

		return (b * 100 + s * 10 + g);
	}
	
	return -1;
}

/**
  * @brief  DNSص
  * @note   ڽɹ󣬻ȻԶȡӦIPַ
  * @param  name:         
  * @param  host_ip:      Ӧipַ
  * @param  callback_arg: ݵĲ
  * @retval None
  */
void http_dns_found(const char *name, ip_addr_t *host_ip, void *callback_arg)
{
	*(ip_addr_t *)callback_arg = *host_ip;
	HTTP_PRINTF("%s:%s\r\n",name, ipaddr_ntoa(host_ip));
}

/**
  * @brief  ӵhttpĺ
	* @note   ӵhttp
  * @param  host:     ipַ
	* @param  port:     ˿ں
	* @param  hostIsIp: host ipַ  0: hostΪ  1: hostΪipַ
	* @retval -1:ӷʧ  -2: ʧ  >=0: ӳɹֵΪ sock
  */
int http_clientConnectToServer(char *host, int port, int hostIsIp)
{
	int timeout;
	struct sockaddr_in serverAddr;
	int sock = socket(AF_INET, SOCK_STREAM, 0);
	if(sock < 0) return -2;	

	//host
	if(hostIsIp == 0)
	{
		ip_addr_t addr;	
		
    addr.addr = 0;
		dns_gethostbyname(host, &addr, http_dns_found, &addr);
		//ȴdns
		timeout = 0;
		while((addr.addr == 0) && (timeout < 2000)) 
		{
			timeout += 10;
			vTaskDelay(100);  
			
		}
		if(timeout >= 2000) 
		{
			HTTP_PRINTF(("dns get failure \n"));
			return -2;
		}
		serverAddr.sin_addr.s_addr = inet_addr(inet_ntoa(addr));
	}
	else serverAddr.sin_addr.s_addr = inet_addr((char*)host);
	serverAddr.sin_len = sizeof(serverAddr);
	serverAddr.sin_family = AF_INET;
	serverAddr.sin_port = htons(port);	
  memset(&serverAddr.sin_zero, 0, sizeof(serverAddr.sin_zero));
	
	//ӷ
	if(connect(sock, (struct sockaddr*)&serverAddr, sizeof(serverAddr)) != 0)
	{
		HTTP_PRINTF("connect server error \r\n");
		return -1;
	}
	
	//ýݳʱʱ
	timeout = 3000;
	setsockopt(sock, SOL_SOCKET, SO_RCVTIMEO, &timeout, sizeof(int));	
	
	HTTP_PRINTF("connect server success \r\n");
	
	return sock;
}

/**
  * @brief  رsocket˿
	* @param  sock:    Ѿӵsock
  */
void http_clientClose(int sock)
{
	close(sock);
}


/**
  * @brief  ӵGET
	* @note   װGETݰGETͳȥ
	* @param  sock:    Ѿӵsock
  * @param  host:    ipַ
	* @param  url:     Դĵַ
	* @retval -1: ʧ 1ͳɹ
  */
int http_clientPacketRequest_GET(int sock, char *host, char *url)
{
	int len;
	
	memset(httpSendBuffer, 0, sizeof(httpSendBuffer));
	//齨
	sprintf((char *)httpSendBuffer, "GET ");
	if(url == NULL) strcat((char *)httpSendBuffer, "/");
	else            strcat((char *)httpSendBuffer, url); 
	strcat((char *)httpSendBuffer, " HTTP/1.1\r\n");
	//齨ͷ 
	strcat((char *)httpSendBuffer, "Host: ");
	strcat((char *)httpSendBuffer, host);	
	strcat((char *)httpSendBuffer, "\r\n");
	strcat((char *)httpSendBuffer, "Connection: close\r\n");	
	strcat((char *)httpSendBuffer, "Accept: application/json\r\n");
	strcat((char *)httpSendBuffer, "User-Agent: gd32f307\r\n");		
	strcat((char *)httpSendBuffer, "Cache-Control: no-cache\r\n");	
	//һհ
	strcat((char *)httpSendBuffer, "\r\n"); 
	len = strlen((char *)httpSendBuffer);
	HTTP_PRINTF("%s", (char *)httpSendBuffer);	 //
	
	//
	len = write(sock, httpSendBuffer, len);  
	if(len <= 0) 
	{
		return -1;
	}
	
	return 1;
}

/**
  * @brief  http_clientReadResponse_GET
	* @note   ȴGETӦ
	* @param  sock:    Ѿӵsock
	* @retval -1: ʧ 1ͳɹ
  */
int http_clientReadResponse_GET(int sock, uint8_t *pbuf, int *datlen)
{
	int len, ret;
	int length = 0;
	
	//ȡӦ
	len = http_getLine(sock, httpRecvBuffer, sizeof(httpRecvBuffer));	
	if(len <= 0) return -1;
	HTTP_PRINTF("%s", (char *)httpRecvBuffer);
	
	ret = http_parseRequestLine(httpRecvBuffer);
	
	//ȡӦͷ
	do
	{
		len = http_getLine(sock, httpRecvBuffer, sizeof(httpRecvBuffer));		
		HTTP_PRINTF("%s", (char *)httpRecvBuffer);
		if(len <= 2) 
		{
			if(len == 2) break;     //ȡ˿
			else         return -1;
		}
	}while(len > 0);
	
	//ȡӦ
	length = 0;
	do
	{
		 len = recv(sock, httpRecvBuffer, sizeof(httpRecvBuffer), 0);
		 if(len > 0) 
		 {
			 memcpy(pbuf + length, httpRecvBuffer, len);
			 length += len;
		 }
	}while(len > 0);
	
	*datlen = length;
	
	return ret;
}

/*
* @brief  http_clientPacketRequest_POST
* @note   齨ͷPOSTͷݰ
* @param  sock:     Ѿӵsock
* @param  host:     IPַ
* @param  url:      Դλ 
* @param  pbuf:     Ҫpostݻ
* @param  datalen   Ҫpostݳ
* @retval           -1: ʧ 1ͳɹ
*/

char httpTmpBuffer[64];
int http_clientPacketRequest_POST(int sock, char *host, char *url, int datalen)
{
	int len;
	
	memset(httpSendBuffer, 0, sizeof(httpSendBuffer));
	//齨
	sprintf((char *)httpSendBuffer, "POST ");
	if(url == NULL) strcat((char *)httpSendBuffer, "/");
	else            strcat((char *)httpSendBuffer, url); 
	strcat((char *)httpSendBuffer, " HTTP/1.1\r\n");
	
	//齨ͷ
	memset(httpTmpBuffer, 0, sizeof(httpTmpBuffer));
	sprintf(httpTmpBuffer, "Host: %s\r\n", host);
	strcat((char *)httpSendBuffer, httpTmpBuffer);
	strcat((char *)httpSendBuffer, "Connection: close\r\n");	
	strcat((char *)httpSendBuffer, "Accept: application/json\r\n");		 //
	strcat((char *)httpSendBuffer, "User-Agent: stm32f207\r\n");			
	strcat((char *)httpSendBuffer, "Cache-Control: no-cache\r\n");	
	strcat((char *)httpSendBuffer, "Content-Type: application/json\r\n");
	memset(httpTmpBuffer, 0, sizeof(httpTmpBuffer));
	sprintf(httpTmpBuffer, "Content-Length: %d\r\n", datalen);   
	strcat((char *)httpSendBuffer, httpTmpBuffer);
	//һհ
	strcat((char *)httpSendBuffer, "\r\n"); 
	
	len = strlen((char *)httpSendBuffer);
	HTTP_PRINTF("%s", (char *)httpSendBuffer);	

	//
	len = write(sock, httpSendBuffer, len);  
	if(len <= 0) 
	{
		return -1;
	}

	return 1;
}


/*
* @brief  http_clientPacketBody_POST
* @note   post
* @param  sock:     Ѿӵsock
* @param  pbuf:     Ҫpostݻ
* @param  datalen   Ҫpostݳ
* @retval           -1: ʧ 1ͳɹ
*/
int http_clientPacketBody_POST(int sock, uint8_t *pbuf, int datalen)
{
	int len;
	
	while(datalen > 1000)
	{
		len = write(sock, pbuf, 1000);  
		if(len <= 0) 
		{
			return -1;
		}
		
	  datalen -= 1000;
		pbuf += 1000;
	}
	
	if(datalen > 0)
	{
		len = write(sock, pbuf, datalen);  
		if(len <= 0) 
		{
			return -1;
		}
	}	
	
	return 1;
}

/*
* @brief  http_clientReadResponse_POST
* @note   ȡͽPOSTصӦ
* @param  sock:     Ѿӵsock
* @retval Ӧķֵ
*/
int http_clientReadResponse_POST(int sock, uint8_t *pbuf, int *datlen)
{
	int len, ret;
	int length = 0;
	
	//ȡӦ
	len = http_getLine(sock, httpRecvBuffer, sizeof(httpRecvBuffer));	
	if(len <= 0) return -1;
	HTTP_PRINTF("%s", (char *)httpRecvBuffer);
	
	ret = http_parseRequestLine(httpRecvBuffer);
	
	//ȡӦͷ
	do
	{
		len = http_getLine(sock, httpRecvBuffer, sizeof(httpRecvBuffer));		
		HTTP_PRINTF("%s", (char *)httpRecvBuffer);
		if(len <= 2) 
		{
			if(len == 2) break;     //ȡ˿
			else         return -1;
		}
	}while(len > 0);	
	
	//ȡӦ
	length = 0;
	do
	{
		 len = recv(sock, httpRecvBuffer, sizeof(httpRecvBuffer), 0);
		 if(len > 0) 
		 {
			 memcpy(pbuf + length, httpRecvBuffer, len);
			 length += len;
		 }
	}while(len > 0);
	
	*datlen = length;
	
	return ret;	
}


/*
* @brief  http_clientGet
* @note   ͻ˷GET
* @param  host:     IPַ
* @param  url:      ʷԴλ
* @param  port:     Ķ˿ں
* @param  hostIsIp: һipַ   0:  1: ipַ
* @param  pbuf:     շӦ
* @param  datalen:  Ӧݵĳ
* @retval ֵ: GET쳣 ֵ: httpЭķ
*/
int http_clientGet(char *host, char *url, uint16_t port, uint8_t hostIsIp, uint8_t *pbuf, int *datalen)
{
	int sock = -1, ret;
	
	sock = http_clientConnectToServer(host, port, hostIsIp);
	if(sock < 0) goto __httpError;
	
	ret = http_clientPacketRequest_GET(sock, host, url);
	if(sock < 0) goto __httpError;
	
	ret = http_clientReadResponse_GET(sock, pbuf, datalen);
	if(sock < 0) goto __httpError;

__httpError:	
	if(sock >= 0)
		http_clientClose(sock);

	return ret;
}

/*
* @brief  http_clientGet
* @note   ͻ˷GET
* @param  host:     IPַ
* @param  url:      ʷԴλ
* @param  port:     Ķ˿ں
* @param  hostIsIp: һipַ   0:  1: ipַ
* @param  postbuf:  Ҫ
* @param  postlen:  ݵĳ
* @param  rtnbuf:     շӦ
* @param  rtnlen:  Ӧݵĳ
* @retval ֵ: GET쳣 ֵ: httpЭķ
*/
int http_clientPost(char *host, char *url, uint16_t port, uint8_t hostIsIp, uint8_t *postbuf, int postlen, uint8_t *rtnbuf, int *rtnlen)
{
	int sock, ret;
	
	sock = http_clientConnectToServer(host, port, hostIsIp);
	if(sock < 0) goto __httpError;

	ret = http_clientPacketRequest_POST(sock, host, url, postlen);
	if(ret < 0) goto __httpError;
	
	ret = http_clientPacketBody_POST(sock, postbuf, postlen);
  if(ret < 0) goto __httpError;
	
	ret = http_clientReadResponse_POST(sock, rtnbuf, rtnlen);

__httpError:	
	if(sock >= 0)
		http_clientClose(sock);
	
	return ret;
}











