
#include "string.h"
#include <stdlib.h>
#include "protocol.h"
#include <stdio.h>   
#include "gateway_message.h"


GATEWAY_PARAMS gateway_config_params = {0};

GATEWAY_PARAMS *get_gateway_config_params()
{
    return &gateway_config_params;
}

void parseStringField(const char *data, const char *field, char *value);
int parseIntField(const char *data, const char *field);
int extract_substring(const char *input_string, const char *start_token, const char *end_token, char *result);
void addSensorListParams(char *paramString, DEVICE_PARAMS *device);
void addCommandListParams(char *paramString, DEVICE_PARAMS *device);
/**
 * @brief  ַؽṹϢݱ
 * @param  char *gatewayString ַ
 * @retval 
 */
	void addGatewayParams(char *gatewayString)
{
		//gateway_config_params.device_params = NULL;
		gateway_config_params.port = parseIntField(gatewayString, "\"port\":");
		gateway_config_params.stopBit = parseIntField(gatewayString, "\"stopBit\":");
		gateway_config_params.dataBits = parseIntField(gatewayString, "\"dataBit\":");
		gateway_config_params.baudrate = parseIntField(gatewayString, "\"baudrate\":");
		gateway_config_params.checkBit = parseIntField(gatewayString, "\"checkBit\":");
		gateway_config_params.inboundTime= parseIntField(gatewayString, "\"inboundTime\":");
		
		parseStringField(gatewayString, "\"host\":\"", (char *)&gateway_config_params.host);
		parseStringField(gatewayString, "\"deviceId\":\"", (char *)&gateway_config_params.deviceId);
		parseStringField(gatewayString, "\"commandTopic\":\"", (char *)&gateway_config_params.commandTopic);
		parseStringField(gatewayString, "\"messageTopic\":\"", (char *)&gateway_config_params.messageTopic);
		parseStringField(gatewayString, "\"username\":\"", (char *)&gateway_config_params.username);
		parseStringField(gatewayString, "\"password\":\"", (char *)&gateway_config_params.passwd);
	
		char *deviceString = strstr(gatewayString,"deviceList");  //λõڵݿʼ
		
		
		while (1)
    {
        if (deviceString)
        {
           addDevice(deviceString); // ˵ַ¹豸Ϣ
           deviceString=deviceString;//»ȡ豸ַλ
					 deviceString = strstr(deviceString, "}"); 
					 deviceString[0]='A';
					 deviceString++;
					 if(deviceString[0]==']')
					 {
					 break;
					 }
        }
        else
        {
            return;
        }
    }
}

/**
 * @brief  ֶεַڸýڵµ豸Ϣ
 * @param  uint8_t *stringַ,NODE_PARAMS *nodeڵϢ
 * @retval 
 */

void addDevice(char *deviceString)
{
    char *paramString = (char *)deviceString; // ָ
		DEVICE_PARAMS *newDevicePage = (DEVICE_PARAMS *)pvPortMalloc(sizeof(DEVICE_PARAMS));    // 豸ҳ
    newDevicePage->nextDevice = NULL;
    newDevicePage->protocol = parseIntField(deviceString, "\"protocol\":");
		newDevicePage->MDBdataType = parseIntField(deviceString, "\"dataType\":");
		newDevicePage->MDBbigLittleFormat = parseIntField(deviceString, "\"bigLittleFormat\":");
		
		parseStringField(deviceString, "\"deviceId\":\"", (char *)&newDevicePage->deviceID);
		
    newDevicePage->params = (PARAMS_PROTOCOL_COMMAND *)pvPortMalloc(sizeof(PARAMS_PROTOCOL_COMMAND));
		memset(newDevicePage->params, 0, sizeof(PARAMS_PROTOCOL_COMMAND));
    paramString = strstr(paramString, "\"sensorData\":["); // ҵýڵѯϷ
    while (1)                                              // ˴ʽ洢Խ治һ
    {
        addSensorListParams(paramString, newDevicePage); // һԲظڸ
				paramString=paramString;
        paramString = strstr(paramString, "}");          // ƶһ
				paramString[0]='A';
        paramString++;
        if (paramString[0] == ']')
        {
            paramString = (char *)deviceString; // ԭָλ
						break;                              // ҵ˽ѭ
        }
    }
		if(newDevicePage->protocol==MODBUS)  //ΪmodbusĻдָ
		{
			paramString=deviceString;                                //ƶʼĵط
			newDevicePage->MDBbigLittleFormat = parseIntField(paramString, "\"bigLittleFormat\":");
      newDevicePage->MDBdataType= parseIntField(paramString, "\"dataType\":");
		  paramString = strstr(paramString, "\"commandData\":["); // ҵѯд
			if(paramString!=NULL)
			{
				while(1)
				{
					addCommandListParams(paramString, newDevicePage);
					paramString = strstr(paramString, "}");
				  paramString[0]='A';
					paramString++;
					if (paramString[0] == ']')
					{
						paramString = (char *)deviceString;// ԭָλ
						break;														 // ҵ˽ѭ
					}
				}
			}
		}
    // ·mqtt洢Ϣ·ָ
		
    // 豸ҳĩβ
    if (gateway_config_params.device_params == NULL)
    {
        gateway_config_params.device_params = newDevicePage;
    }
    else
    {
        DEVICE_PARAMS *current = gateway_config_params.device_params;
        while (current->nextDevice != NULL)
        {
            current = current->nextDevice;
        }
        current->nextDevice = newDevicePage;
    }
		//modbus commandָص豸
		
}
/**
 * @brief  ַparamString,ݱ浽豸ṹ£˴sensorList
 * @param  uint8_t *paramStringַ,DEVICE_PARAMS *deviceڵϢ
 * @retval 
 */
void addSensorListParams(char *paramString, DEVICE_PARAMS *device)
{
    switch (device->protocol)
    {
    case DLT645_97:
    case DLT645_07:
		{
        GATEWAY_READ_DLT645_COMMAND *read_dlt645_command = pvPortMalloc(sizeof(GATEWAY_READ_DLT645_COMMAND));
        read_dlt645_command->Identification = parseIntField(paramString, "\"identifier645\":");
        parseStringField(paramString, "\"identifier\":\"", (char *)&read_dlt645_command->keyword);
        char *string = pvPortMalloc(13);
        parseStringField(paramString, "\"deviceID645\":\"", string);
        for (int j = 0; j < 6; j++)
        {
          uint8_t byte;
          sscanf((const char *)&string[j * 2], "%2hhx", &byte);
          read_dlt645_command->deviceID645[j]=byte;
        }				
        vPortFree(string);
				string = NULL;
        if (device->params->gateway_read_dlt645_command == NULL)
        {
            device->params->gateway_read_dlt645_command = read_dlt645_command;
        }
        else
        {
            GATEWAY_READ_DLT645_COMMAND *current = device->params->gateway_read_dlt645_command;
            while (current->nextParams != NULL)
            {
                current = current->nextParams;
            }
            current->nextParams = read_dlt645_command;
        }
			}
				
        break;
    case MODBUS:
		{
        GATEWAY_READ_MODBUS_COMMAND *read_modbus_command = pvPortMalloc(sizeof(GATEWAY_READ_MODBUS_COMMAND));
				memset(read_modbus_command, 0, sizeof(GATEWAY_READ_MODBUS_COMMAND));
				parseStringField(paramString,"\"identifier\":\"",(char *)&read_modbus_command->keyword);
        read_modbus_command->decimalPoint = parseIntField(paramString, "\"precise\":");
        read_modbus_command->functionCode = parseIntField(paramString, "\"rFunctionCode\":");
        read_modbus_command->slaveAddress = parseIntField(paramString, "\"slaveAddress\":");
        read_modbus_command->registerAddress = parseIntField(paramString, "\"registerAddress\":");
        read_modbus_command->registerByteNum = parseIntField(paramString, "\"registerByteNum\":");
        
			if (device->params->gateway_read_modbus_command== NULL)
        {
            device->params->gateway_read_modbus_command = read_modbus_command;
        }
        else
        {
            GATEWAY_READ_MODBUS_COMMAND *current = device->params->gateway_read_modbus_command;
            while (current->nextParams != NULL)
            {
                current = current->nextParams;
            }
            current->nextParams = read_modbus_command;
        }
			}
        break;
    default:
        break;
    }
}
/**
 * @brief  ַparamString,ݱ浽豸ṹ£˴commandList
 * @param  uint8_t *paramStringַ,DEVICE_PARAMS *deviceڵϢ
 * @retval 
 */
void addCommandListParams(char *paramString, DEVICE_PARAMS *device)
{
	
 	GATEWAY_WRITE_MODBUS_COMMAND *write_modbus_command=pvPortMalloc(sizeof(GATEWAY_WRITE_MODBUS_COMMAND));
	memset(write_modbus_command, 0, sizeof(GATEWAY_WRITE_MODBUS_COMMAND));
	parseStringField(paramString,"\"identifier\":\"",(char *)&write_modbus_command->keyword);
	write_modbus_command->functionCode=parseIntField(paramString, "\"wFunctionCode\":");
	write_modbus_command->slaveAddress=parseIntField(paramString, "\"slaveAddress\":");
	write_modbus_command->registerAddress = parseIntField(paramString, "\"registerAddress\":");
	write_modbus_command->registerByteNum = parseIntField(paramString, "\"registerByteNum\":");
	if(device->params->gateway_write_modbus_command == NULL)
	{
		device->params->gateway_write_modbus_command=write_modbus_command;
	}
	else
	{
		GATEWAY_WRITE_MODBUS_COMMAND *current=device->params->gateway_write_modbus_command;
    while (current->nextParams != NULL)
    {
      current = current->nextParams;
    }
    current->nextParams = write_modbus_command;		
	}
}
// ȡint
int parseIntField(const char *data, const char *field)
{
	int r;
	char* i;
	i = strstr(data, field);
	r = strlen(field);
    char *ptr = strstr(data, field) + strlen(field);
    int value;
    value = strtol(ptr, &ptr, 10);
    return value;
}

// ȡstringַ
void parseStringField(const char *data, const char *field, char *value)
{
    char *ptr = strstr(data, field) + strlen(field);
    sscanf(ptr, "%[^\"],", value);
}

// jsonӲjson
void processStringJson(uint8_t *data)
{
    GATEWAY_PARAMS *gateway;
    gateway = get_gateway_config_params();
    uint8_t *ptr = (uint8_t *)data;
    parseStringField((char *)&ptr, "\"messageTopic\":\"", (char *)&gateway->messageTopic);
    parseStringField((char *)&ptr, "\"commandTopic\":\"", (char *)&gateway->commandTopic);
    gateway->port = parseIntField((char *)&ptr, "\"port\":\"");
    parseStringField((char *)&ptr, "\"host\":\"", (char *)&gateway->host);
    parseStringField((char *)&ptr, "\"deviceId\":\"", (char *)&gateway->deviceId);
    // ,ռ洢ڵϢ

    int nodeNum = 1;
    char *node_index = pvPortMalloc(10);
    sprintf(node_index, "node_%d", nodeNum);
    strstr(ptr, node_index); // ָָһڵ
    while (*ptr == NULL)
    {

    }
    vPortFree(node_index);
}
/**
 * @brief  input_stringѰҿʼλõַݣݽȡresult;
 * @param  input_stringַstart_tokenַʼλãend_tokenַλãresultȡַ
 * @retval 0:ûбȡַ1бȡַ
 */
int extract_substring(const char *input_string, const char *start_token, const char *end_token, char *result)
{
    const char *start_ptr = strstr(input_string, start_token);

    if (start_ptr == NULL)
    {
        return 0; // δҵʼ
    }

    start_ptr += strlen(start_token); // ƶָ뵽ʼ֮

    const char *end_ptr = strstr(start_ptr, end_token);

    if (end_ptr == NULL)
    {
        // δҵǣʼǿʼַһֱƵ \0 
        strcpy(result, start_ptr);
    }
    else
    {
        // ҵǣȡĳȲ
        size_t length = end_ptr - start_ptr;
        strncpy(result, start_ptr, length);
        result[length] = '\0'; // ַ
    }
    return 1;
}


